Subject: [netmod] create and delete operations on default values

From: Andy Bierman <[email-masked]>
Date: Mon, 15 Feb 2010 08:48:00 -0800

Hi,

I understand that the NETMOD WG thinks it is important
to treat leafs with the YANG default value as if they
MUST NOT exist.  IMO, this should be a vendor choice,
but oh well.

I think the 4741bis draft needs to explain how the
create and delete operation is applied to leafs
containing the schema default value.

   leaf foo {
      type int32;
      default 42;
   }

It is not clear to me when a create operation
on the /foo leaf is expected to succeed and when
it expected to fail with a 'data-exists' error.

   - will it succeed if the server set this to 42?
     we know it will fail if a client already set it to 42.

What about the same question for a delete operation?
Does the server choose based on its 'basic' mode
of the with-defaults capability?  What if this
capability is not supported?  What if the behavior
is not the same for every object in the database?

If I have a module that was defined in SMIv2, XSD, RNG, or
some other DML, then it seems I cannot reliably convert
a default in that data model to YANG default-stmt.
It seems advertising the YANG version instead of the XSD
version will have an impact on NETCONF protocol operations.

Andy